diff --git a/src/reader.c b/src/reader.c
index afaf4ee87..1b5c5fc7b 100644
--- a/src/reader.c
+++ b/src/reader.c
@@ -130,6 +130,8 @@ size_t ecs_component_reader(
         ecs_abort(ECS_INTERNAL_ERROR, NULL);
     }
 
+    ecs_assert(read % 4 == 0, ECS_INTERNAL_ERROR, NULL);
+
     return read;
 }
 
@@ -209,18 +211,10 @@ void ecs_table_reader_next(
         reader->column = &reader->columns[reader->column_index];
         reader->column_data = ecs_vector_first(reader->column->data);
         reader->row_index = 0;
-        reader->name = ((EcsId*)reader->column_data)[0];
-        reader->name_len = strlen(reader->name);
-        reader->name_written = 0;
         break;
 
     case EcsTableColumnNameLength:
         reader->state = EcsTableColumnName;
-        if (reader->row_index < reader->row_count) {
-            reader->name = ((EcsId*)reader->column_data)[reader->row_index];
-            reader->name_len = strlen(reader->name) + 1;
-            reader->name_written = 0;
-        }
         reader->row_index ++;
         break;
 
@@ -341,6 +335,8 @@ size_t ecs_table_reader(
             /* Set read to align so that data is always aligned to 4 bytes */
             read = align;
 
+            printf("read = %d, size = %d\n", read, size);
+
             /* Buffer sizes are expected to be aligned to 4 bytes and the rest
              * of the serialized data is aligned to 4 bytes. Should never happen
              * that adding padding bytes exceeds the size. */
@@ -360,7 +356,10 @@ size_t ecs_table_reader(
         break;
 
     case EcsTableColumnNameLength:
-        *(int32_t*)buffer = strlen(reader->name) + 1;
+        reader->name = ((EcsId*)reader->column_data)[reader->row_index];
+        reader->name_len = strlen(reader->name) + 1;
+        reader->name_written = 0;
+        *(int32_t*)buffer = reader->name_len;
         read = sizeof(int32_t);
         ecs_table_reader_next(stream);    
         break;
@@ -389,6 +388,8 @@ size_t ecs_table_reader(
         ecs_abort(ECS_INTERNAL_ERROR, NULL);
     }
 
+    ecs_assert(read % 4 == 0, ECS_INTERNAL_ERROR, NULL);
+
     return read;
 }
 
@@ -404,6 +405,7 @@ size_t ecs_reader_read(
     }
 
     ecs_assert(size >= sizeof(int32_t), ECS_INVALID_PARAMETER, NULL);
+    ecs_assert(size % 4 == 0, ECS_INVALID_PARAMETER, NULL);
 
     if (reader->state == EcsComponentSegment) {
         while ((read = ecs_component_reader(ECS_OFFSET(buffer, total_read), remaining, reader))) {
@@ -417,6 +419,8 @@ size_t ecs_reader_read(
             if (reader->state != EcsComponentSegment) {
                 break;
             }
+
+            ecs_assert(remaining % 4 == 0, ECS_INTERNAL_ERROR, NULL);
         }
 
         if (read == -1) {
@@ -435,7 +439,9 @@ size_t ecs_reader_read(
 
             if (reader->state != EcsTableSegment) {
                 break;
-            }            
+            }
+
+            ecs_assert(remaining % 4 == 0, ECS_INTERNAL_ERROR, NULL);        
         }
     }  
     
diff --git a/src/writer.c b/src/writer.c
index 7b2dadb26..149de50fa 100644
--- a/src/writer.c
+++ b/src/writer.c
@@ -25,7 +25,7 @@ bool ecs_name_writer_write(
     if (written >= sizeof(int32_t)) {
         *(int32_t*)name_ptr = *(int32_t*)buffer;
         writer->written += sizeof(int32_t);
-        return written != sizeof(int32_t);
+        return writer->written != writer->len;
     } else {
         memcpy(name_ptr, buffer, written);
         writer->written += written;
@@ -435,6 +435,7 @@ int ecs_writer_write(
     }
 
     ecs_assert(size >= sizeof(uint32_t), ECS_INVALID_PARAMETER, NULL);
+    ecs_assert(size % 4 == 0, ECS_INVALID_PARAMETER, NULL);
 
     while (total_written < size) {
         if (writer->state == EcsStreamHeader) {
@@ -443,6 +444,7 @@ int ecs_writer_write(
             if (writer->state != EcsComponentHeader &&
                 writer->state != EcsTableHeader)
             {
+                printf("Invalid stream header\n");
                 writer->error = ECS_DESERIALIZE_FORMAT_ERROR;
                 goto error;
             }
diff --git a/test/api/project.json b/test/api/project.json
index 91b0d244c..2dd67b6ba 100644
--- a/test/api/project.json
+++ b/test/api/project.json
@@ -912,7 +912,11 @@
                 "simple_w_4_byte_buffer",
                 "simple_w_exact_buffer",
                 "simple_w_smaller_buffer",
-                "simple_w_larger_buffer"
+                "simple_w_larger_buffer",
+                "id_w_4_byte_buffer",
+                "id_w_exact_buffer",
+                "id_w_smaller_buffer",
+                "id_w_larger_buffer"               
             ]
         }, {
             "id": "FilterIter",
diff --git a/test/api/src/ReaderWriter.c b/test/api/src/ReaderWriter.c
index 72e8301e1..da691efdc 100644
--- a/test/api/src/ReaderWriter.c
+++ b/test/api/src/ReaderWriter.c
@@ -1,5 +1,10 @@
 #include <api.h>
 
+static
+int align(int value, int align_to) {
+    return (((value - 1) / align_to) + 1) * align_to;
+}
+
 static
 ecs_vector_t* serialize_to_vector(
     ecs_world_t *world, 
@@ -66,7 +71,8 @@ ecs_world_t* deserialize_from_vector(
     return world;
 }
 
-void ReaderWriter_simple_w_4_byte_buffer() {
+static
+int simple_test(int buffer_size) {
     ecs_world_t *world = ecs_init();
 
     ECS_COMPONENT(world, Position);
@@ -75,11 +81,11 @@ void ReaderWriter_simple_w_4_byte_buffer() {
     ecs_entity_t e2 = ecs_set(world, 0, Position, {3, 4});
     ecs_entity_t e3 = ecs_set(world, 0, Position, {5, 6});
 
-    ecs_vector_t *v = serialize_to_vector(world, 4);
+    ecs_vector_t *v = serialize_to_vector(world, buffer_size);
 
     ecs_fini(world);
 
-    world = deserialize_from_vector(v, 4);
+    world = deserialize_from_vector(v, buffer_size);
 
     test_assert( !ecs_is_empty(world, e1));
     test_assert( !ecs_is_empty(world, e2));
@@ -89,17 +95,196 @@ void ReaderWriter_simple_w_4_byte_buffer() {
     test_assert( ecs_has(world, e2, Position));
     test_assert( ecs_has(world, e3, Position));
 
+    Position *
+    p = ecs_get_ptr(world, e1, Position);
+    test_int(p->x, 1);
+    test_int(p->y, 2);
+
+    p = ecs_get_ptr(world, e2, Position);
+    test_int(p->x, 3);
+    test_int(p->y, 4);
+
+    p = ecs_get_ptr(world, e3, Position);
+    test_int(p->x, 5);
+    test_int(p->y, 6);        
+
     ecs_fini(world);
+
+    int total = ecs_vector_count(v);
+    ecs_vector_free(v);
+    return total;
+}
+
+void ReaderWriter_simple_w_4_byte_buffer() {
+    simple_test(4);
 }
 
 void ReaderWriter_simple_w_exact_buffer() {
-    // Implement testcase
+    int total = simple_test(4);
+    test_assert(total > 4);
+    test_assert(total % 4 == 0);
+    simple_test(total);
 }
 
 void ReaderWriter_simple_w_smaller_buffer() {
-    // Implement testcase
+    int total = simple_test(4);
+    test_assert(total > 4);
+    test_assert(total % 4 == 0);
+    int smaller = align(total / 2, 4);
+    simple_test(smaller);
 }
 
 void ReaderWriter_simple_w_larger_buffer() {
-    // Implement testcase
+    int total = simple_test(4);
+    test_assert(total > 4);
+    test_assert(total % 4 == 0);
+    simple_test(total * 2);
+}
+
+static
+int id_test(int buffer_size) {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    
+    /* Entities with different name lengths to test if alignment & fragmentation
+     * works properly */
+    ecs_entity_t e1 = 
+    ecs_set(world, 0, EcsId, {""});
+    ecs_set(world, e1, Position, {1, 2});
+
+    ecs_entity_t e2 = 
+    ecs_set(world, 0, EcsId, {"E"});
+    ecs_set(world, e2, Position, {3, 4});
+
+    ecs_entity_t e3 = 
+    ecs_set(world, 0, EcsId, {"E3"});
+    ecs_set(world, e3, Position, {5, 6});
+
+    ecs_entity_t e4 = 
+    ecs_set(world, 0, EcsId, {"E4E"});
+    ecs_set(world, e4, Position, {7, 8});
+
+    ecs_entity_t e5 = 
+    ecs_set(world, 0, EcsId, {"E5E5"});
+    ecs_set(world, e5, Position, {9, 10});
+
+    ecs_entity_t e6 = 
+    ecs_set(world, 0, EcsId, {"E6E6E"});
+    ecs_set(world, e6, Position, {11, 12});   
+
+    ecs_entity_t e7 = 
+    ecs_set(world, 0, EcsId, {"E7E7E7E"});
+    ecs_set(world, e7, Position, {13, 14});  
+
+    ecs_entity_t e8 = 
+    ecs_set(world, 0, EcsId, {"E8E8E8E8"});
+    ecs_set(world, e8, Position, {15, 16});
+
+    ecs_vector_t *v = serialize_to_vector(world, buffer_size);
+
+    ecs_fini(world);
+
+    world = deserialize_from_vector(v, buffer_size);
+
+    test_assert( !ecs_is_empty(world, e1));
+    test_assert( !ecs_is_empty(world, e2));
+    test_assert( !ecs_is_empty(world, e3));
+    test_assert( !ecs_is_empty(world, e4));
+    test_assert( !ecs_is_empty(world, e5));
+    test_assert( !ecs_is_empty(world, e6));
+    test_assert( !ecs_is_empty(world, e7));
+    test_assert( !ecs_is_empty(world, e8));
+
+    test_assert( ecs_has(world, e1, Position));
+    test_assert( ecs_has(world, e2, Position));
+    test_assert( ecs_has(world, e3, Position));
+    test_assert( ecs_has(world, e4, Position));
+    test_assert( ecs_has(world, e5, Position));
+    test_assert( ecs_has(world, e6, Position));
+    test_assert( ecs_has(world, e7, Position));
+    test_assert( ecs_has(world, e8, Position));
+    
+    test_assert( ecs_has(world, e1, EcsId));
+    test_assert( ecs_has(world, e2, EcsId));
+    test_assert( ecs_has(world, e3, EcsId));
+    test_assert( ecs_has(world, e4, EcsId));
+    test_assert( ecs_has(world, e5, EcsId));
+    test_assert( ecs_has(world, e6, EcsId));
+    test_assert( ecs_has(world, e7, EcsId));
+    test_assert( ecs_has(world, e8, EcsId));    
+
+    Position *
+    p = ecs_get_ptr(world, e1, Position);
+    test_int(p->x, 1);
+    test_int(p->y, 2);
+
+    p = ecs_get_ptr(world, e2, Position);
+    test_int(p->x, 3);
+    test_int(p->y, 4);
+
+    p = ecs_get_ptr(world, e3, Position);
+    test_int(p->x, 5);
+    test_int(p->y, 6);  
+
+    p = ecs_get_ptr(world, e4, Position);
+    test_int(p->x, 7);
+    test_int(p->y, 8);  
+
+    p = ecs_get_ptr(world, e5, Position);
+    test_int(p->x, 9);
+    test_int(p->y, 10);  
+
+    p = ecs_get_ptr(world, e6, Position);
+    test_int(p->x, 11);
+    test_int(p->y, 12);  
+
+    p = ecs_get_ptr(world, e7, Position);
+    test_int(p->x, 13);
+    test_int(p->y, 14);  
+
+    p = ecs_get_ptr(world, e8, Position);
+    test_int(p->x, 15);
+    test_int(p->y, 16);
+
+    test_str( ecs_get_id(world, e1), "");
+    test_str( ecs_get_id(world, e2), "E");
+    test_str( ecs_get_id(world, e3), "E3");
+    test_str( ecs_get_id(world, e4), "E4E");
+    test_str( ecs_get_id(world, e5), "E5E5");
+    test_str( ecs_get_id(world, e6), "E6E6E");
+    test_str( ecs_get_id(world, e7), "E7E7E7E");
+    test_str( ecs_get_id(world, e8), "E8E8E8E8");
+
+    ecs_fini(world);
+
+    int total = ecs_vector_count(v);
+    ecs_vector_free(v);
+    return total;
+}
+
+void ReaderWriter_id_w_4_byte_buffer() {
+    id_test(4);
+}
+
+void ReaderWriter_id_w_exact_buffer() {
+    int total = id_test(4);
+    test_assert(total > 4);
+    test_assert(total % 4 == 0);
+    id_test(total);
+}
+
+void ReaderWriter_id_w_smaller_buffer() {
+    int total = id_test(4);
+    test_assert(total > 4);
+    test_assert(total % 4 == 0);
+    int smaller = align(total / 2, 4);
+    id_test(smaller);
+}
+
+void ReaderWriter_id_w_larger_buffer() {
+    int total = id_test(4);
+    test_assert(total > 4);
+    test_assert(total % 4 == 0);
+    id_test(total * 2);
 }
diff --git a/test/api/src/main.c b/test/api/src/main.c
index 532b09da6..bb2dd86c8 100644
--- a/test/api/src/main.c
+++ b/test/api/src/main.c
@@ -834,6 +834,10 @@ void ReaderWriter_simple_w_4_byte_buffer(void);
 void ReaderWriter_simple_w_exact_buffer(void);
 void ReaderWriter_simple_w_smaller_buffer(void);
 void ReaderWriter_simple_w_larger_buffer(void);
+void ReaderWriter_id_w_4_byte_buffer(void);
+void ReaderWriter_id_w_exact_buffer(void);
+void ReaderWriter_id_w_smaller_buffer(void);
+void ReaderWriter_id_w_larger_buffer(void);
 
 // Testsuite 'FilterIter'
 void FilterIter_iter_one_table(void);
@@ -4086,7 +4090,7 @@ static bake_test_suite suites[] = {
     },
     {
         .id = "ReaderWriter",
-        .testcase_count = 4,
+        .testcase_count = 8,
         .testcases = (bake_test_case[]){
             {
                 .id = "simple_w_4_byte_buffer",
@@ -4103,6 +4107,22 @@ static bake_test_suite suites[] = {
             {
                 .id = "simple_w_larger_buffer",
                 .function = ReaderWriter_simple_w_larger_buffer
+            },
+            {
+                .id = "id_w_4_byte_buffer",
+                .function = ReaderWriter_id_w_4_byte_buffer
+            },
+            {
+                .id = "id_w_exact_buffer",
+                .function = ReaderWriter_id_w_exact_buffer
+            },
+            {
+                .id = "id_w_smaller_buffer",
+                .function = ReaderWriter_id_w_smaller_buffer
+            },
+            {
+                .id = "id_w_larger_buffer",
+                .function = ReaderWriter_id_w_larger_buffer
             }
         }
     },
